;****************************************************************
; Sound Auditioning USER and INIT Routines			*
;****************************************************************
; USR_Audition is the USER routine, called instead of the game
; routines every frame.
;
; INIT_Audition is the INIT routine, called if GLO_ForceInit is
; set (it will clear it once its done).

.section "Audition" force

; Label Tabel
;-------------
; Column	     0.......8......10......18......20.....27"
_audHeader	.db "     ~HuListen Auditioning Suite~",0

_audChannelReg	.db " <!!> VOL : xx, PAN : xx, FREQ : xxxx",0
_audChannelMod	.db " <!!> PRI : xx, MODE : xxxxx",0

_audBGMSel	.db "  BGM : xx",0
_audSFXSel	.db "  SFX : xx",0
_audSampleSel	.db "  Voice : xx",0
_audAttenSel	.db "  Atten : xx",0
_audSelActive	.db " *",0
_audSelIdle	.db "  ",0

_audSelLo	.db <_audAttenSel,<_audSampleSel,<_audSFXSel,<_audBGMSel
_audSelHi	.db >_audAttenSel,>_audSampleSel,>_audSFXSel,>_audBGMSel

_audSelVarLo	.db <Audition_CurBGM,<Audition_CurSFX,<Audition_CurSample,<Audition_CurAtten
_audSelVarHi	.db >Audition_CurBGM,>Audition_CurSFX,>Audition_CurSample,>Audition_CurAtten
_audSelMaxLo	.db <HuMusic_NumTracks,<HuSFX_NumSFX,<HuSample_NumSamples,<_audSelMaxAtten
_audSelMaxHi	.db >HuMusic_NumTracks,>HuSFX_NumSFX,>HuSample_NumSamples,>_audSelMaxAtten
_audSelVarOff	.db 8,72,138,202

_audSelMaxAtten .db 16

_audSelA_ActLo	.db <HuMusic_TrackReq,<_playSFX,<HuSample_PlaySimple,<HuMusic_ReqAtten
_audSelA_ActHi	.db >HuMusic_TrackReq,>_playSFX,>HuSample_PlaySimple,>HuMusic_ReqAtten
_audSelB_ActLo	.db <HuMusic_Stop,<HuSFX_StopAll,<HuSample_StopSimple,<HuMusic_ReqAtten
_audSelB_ActHi	.db >HuMusic_Stop,>HuSFX_StopAll,>HuSample_StopSimple,>HuMusic_ReqAtten

; Soft-Wave Tiles
;-----------------
_audWaveTiles	.dw (VCEL_USERBASE + $00),(VCEL_USERBASE + $02)
		.dw (VCEL_USERBASE + $04),(VCEL_USERBASE + $06),0
		.dw (VCEL_USERBASE + $01),(VCEL_USERBASE + $03)
		.dw (VCEL_USERBASE + $05),(VCEL_USERBASE + $07),0

		.dw (VCEL_USERBASE + $08),(VCEL_USERBASE + $0A)
		.dw (VCEL_USERBASE + $0C),(VCEL_USERBASE + $0E),0
		.dw (VCEL_USERBASE + $09),(VCEL_USERBASE + $0B)
		.dw (VCEL_USERBASE + $0D),(VCEL_USERBASE + $0F),0

		.dw (VCEL_USERBASE + $10),(VCEL_USERBASE + $12)
		.dw (VCEL_USERBASE + $14),(VCEL_USERBASE + $16),0
		.dw (VCEL_USERBASE + $11),(VCEL_USERBASE + $13)
		.dw (VCEL_USERBASE + $15),(VCEL_USERBASE + $17),0

		.dw (VCEL_USERBASE + $18),(VCEL_USERBASE + $1A)
		.dw (VCEL_USERBASE + $1C),(VCEL_USERBASE + $1E),0
		.dw (VCEL_USERBASE + $19),(VCEL_USERBASE + $1B)
		.dw (VCEL_USERBASE + $1D),(VCEL_USERBASE + $1F),0

		.dw (VCEL_USERBASE + $20),(VCEL_USERBASE + $22)
		.dw (VCEL_USERBASE + $24),(VCEL_USERBASE + $26),0
		.dw (VCEL_USERBASE + $21),(VCEL_USERBASE + $23)
		.dw (VCEL_USERBASE + $25),(VCEL_USERBASE + $27),0

		.dw (VCEL_USERBASE + $28),(VCEL_USERBASE + $2A)
		.dw (VCEL_USERBASE + $2C),(VCEL_USERBASE + $2E),0
		.dw (VCEL_USERBASE + $29),(VCEL_USERBASE + $2B)
		.dw (VCEL_USERBASE + $2D),(VCEL_USERBASE + $2F),0

_audWaveSrcsLo	.db <(_audWaveTiles + 000),<(_audWaveTiles + 010)
		.db <(_audWaveTiles + 020),<(_audWaveTiles + 030)
		.db <(_audWaveTiles + 040),<(_audWaveTiles + 050)
		.db <(_audWaveTiles + 060),<(_audWaveTiles + 070)
		.db <(_audWaveTiles + 080),<(_audWaveTiles + 090)
		.db <(_audWaveTiles + 100),<(_audWaveTiles + 110)

_audWaveSrcsHi	.db >(_audWaveTiles + 000),>(_audWaveTiles + 010)
		.db >(_audWaveTiles + 020),>(_audWaveTiles + 030)
		.db >(_audWaveTiles + 040),>(_audWaveTiles + 050)
		.db >(_audWaveTiles + 060),>(_audWaveTiles + 070)
		.db >(_audWaveTiles + 080),>(_audWaveTiles + 090)
		.db >(_audWaveTiles + 100),>(_audWaveTiles + 110)

_audWaveDestsLo	.db <($00C1),<($0101),<($0181),<($01C1)
		.db <($0241),<($0281),<($0301),<($0341)
		.db <($03C1),<($0401),<($0481),<($04C1)

_audWaveDestsHi	.db >($00C1),>($0101),>($0181),>($01C1)
		.db >($0241),>($0281),>($0301),>($0341)
		.db >($03C1),>($0401),>($0481),>($04C1)

;****************************************************************
; USR_Audition:							*
;****************************************************************
USR_Audition:
	LDA GLO_ForceInit
	beq _initDone
	jsr INIT_Audition

_initDone

	LDX #(HUSOUND_CHANNELS - 1)	; ---- STATE DISPLAYS ----
_drawStates
	jsr Audition_DrawState
	DEX
	bpl _drawStates


	LDY Audition_CurSel		; ---- BGM/SFX/VOICE/ATTEN SELECTION ----
	LDA JOY_Pressed			; Up / Down selects which the user will
	AND #GAMESTICK_UP		; be able to adjust (Audition_CurSel).
	beq _checkDown			; 0 = BGM, 1 = SFX, 2 = Voice, 3 = Atten

	DEY
	bpl _setSel
	LDY #3
	bra _setSel
_checkDown
	LDA JOY_Pressed
	AND #GAMESTICK_DOWN
	beq _setSel

	INY
	CPY #4
	bne _setSel
	LDY #0
_setSel
	STY Audition_CurSel


	LDA #$40			; Draw the state of selection for the BGM,
	STA GLO_TempC			; SFX, and Voice fields. Place a "*" next to
	LDA #$05			; whichever one is currently active.
	STA GLO_TempD
	CLY
_drawSelState
	CPY Audition_CurSel
	bne _selInactive

	LDA #<_audSelActive
	STA DBG_TextSrc + LO
	LDA #>_audSelActive
	STA DBG_TextSrc + HI
	bra _moveNextSel
_selInactive
	LDA #<_audSelIdle
	STA DBG_TextSrc + LO
	LDA #>_audSelIdle
	STA DBG_TextSrc + HI

_moveNextSel
	jsr _cursorDraw
	jsr _carriageReturn
	INY
	CPY #4
	bne _drawSelState


	LDY Audition_CurSel		; ---- ADJUST SELECTION ----
	LDA _audSelVarLo,Y
	STA GLO_PointerC + LO
	LDA _audSelVarHi,Y
	STA GLO_PointerC + HI
	LDA _audSelMaxLo,Y
	STA GLO_PointerD + LO
	LDA _audSelMaxHi,Y
	STA GLO_PointerD + HI

	LDA (GLO_PointerC)
	TAY
	LDA (GLO_PointerD)		; If the number of tracks, sfx, or samples
	beq _setValue			; is zero, just skip the adjustment entirely.

	LDA JOY_Pressed
	AND #GAMESTICK_LEFT
	beq _checkIncrement

	DEY
	bpl _setValue
	LDA (GLO_PointerD)
	TAY
	DEY
	bra _setValue
_checkIncrement
	LDA JOY_Pressed
	AND #GAMESTICK_RIGHT
	beq _setValue

	INY
	TYA
	CMP (GLO_PointerD)
	bne _setValue
	CLY
_setValue
	TYA
	STA (GLO_PointerC)

	LDY #3
_drawSelval
	clc
	LDA #$40
	ADC _audSelVarOff,Y
	STA DBG_TextDest + LO
	LDA #$05
	ADC #$00
	STA DBG_TextDest + HI

	LDA _audSelVarLo,Y
	STA GLO_PointerC + LO
	LDA _audSelVarHi,Y
	STA GLO_PointerC + HI
	LDA (GLO_PointerC)
	jsr DBG_PrintHex
	DEY
	bpl _drawSelval


	LDY Audition_CurSel
	LDA _audSelVarLo,Y
	STA GLO_PointerC + LO
	LDA _audSelVarHi,Y
	STA GLO_PointerC + HI
	LDA (GLO_PointerC)
	STA GLO_TempC

	LDA JOY_Pressed			; ---- DISPATCH ACTION ----
	AND #GAMESTICK_A		; If A or B is pressed, perform the subroutine
	beq _checkStop			; call associated with the current selection
					; (luckily, they all have similar syntax).
	LDA _audSelA_ActLo,Y
	STA GLO_PointerD + LO
	LDA _audSelA_ActHi,Y
	STA GLO_PointerD + HI
	LDA GLO_TempC
	jmp (GLO_PointerD + ADDR_RAM)
_checkStop
	LDA JOY_Pressed
	AND #GAMESTICK_B
	beq _noStop

	LDA _audSelB_ActLo,Y
	STA GLO_PointerD + LO
	LDA _audSelB_ActHi,Y
	STA GLO_PointerD + HI
	LDA GLO_TempC
	jmp (GLO_PointerD + ADDR_RAM)
_noStop
_dummyAction
	rts




;****************************************************************
; INIT_Audition:						*
; Set up the sound auditioning screen (mostly printing the base	*
; labels), trashes GLO_TempC and GLO_TempD.			*
;****************************************************************
INIT_Audition:
	LDA #$FF
	STA GLO_isPausable		; Yes, we will allow pausing here

	LDA #(VDC_ENABLE_BG | VDC_IRQ_VBL | VDC_IRQ_HBL)
	STA VDCM_CR + LO		; Disable sprites, then reset the
	STZ VDCM_CR + HI		; scroll coordinates to 0,0 and
	STZ VDCM_BXR + LO		; set our map size to the default
	STZ VDCM_BXR + HI		; of 64x32 tiles.
	STZ VDCM_BYR + LO
	STZ VDCM_BYR + HI
	LDA #VDC_MAP_64x32
	STA VDCM_MWR + LO
	STZ VDCM_MWR + HI

	LDA #<_audHeader		; Stamp our header text
	STA DBG_TextSrc + LO
	LDA #>_audHeader
	STA DBG_TextSrc + HI
	LDA #64
	STA DBG_TextDest + LO
	STZ DBG_TextDest + HI
	jsr DBG_Print

	LDA #$C0			; Then the channel labels, the
	STA GLO_TempC			; dynamic portions will be filled
	STZ GLO_TempD			; in later on (during exec).
	LDY #(HUSOUND_CHANNELS - 1)
_stampChannel
	LDA #<_audChannelReg
	STA DBG_TextSrc + LO
	LDA #>_audChannelReg
	STA DBG_TextSrc + HI
	jsr _cursorDraw
	jsr _carriageReturn

	LDA #<_audChannelMod
	STA DBG_TextSrc + LO
	LDA #>_audChannelMod
	STA DBG_TextSrc + HI
	jsr _cursorDraw
	jsr _carriageReturn

	jsr _carriageReturn
	DEY
	bpl _stampChannel

	LDA #$40
	STA GLO_TempC
	LDA #$05
	STA GLO_TempD
	LDY #3
_stampSel
	LDA _audSelLo,Y
	STA DBG_TextSrc + LO
	LDA _audSelHi,Y
	STA DBG_TextSrc + HI
	jsr _cursorDraw
	jsr _carriageReturn
	DEY
	bpl _stampSel


	LDY #((HUSOUND_CHANNELS * 2) - 1)
_stampWaves
	LDA _audWaveSrcsLo,Y
	STA DBG_TextSrc + LO
	LDA _audWaveSrcsHi,Y
	STA DBG_TextSrc + HI

	LDA _audWaveDestsLo,Y
	STA DBG_TextDest + LO
	LDA _audWaveDestsHi,Y
	STA DBG_TextDest + HI
	jsr DBG_PrintTile
	DEY
	bpl _stampWaves


_clearUser
	STZ Audition_CurSel
	STZ Audition_CurBGM
	STZ Audition_CurSFX
	STZ Audition_CurSample

	STZ GLO_ForceInit		; Finished...
	rts


;****************************************************************
; Sound Effect Call Wrappers					*
;****************************************************************
_playSFX
	LDY #$FF
	jmp HuSFX_Play


;****************************************************************
; Typewriter Tools						*
;****************************************************************
_carriageReturn
	clc
	LDA GLO_TempC
	ADC #$40
	STA GLO_TempC
	LDA GLO_TempD
	ADC #0
	STA GLO_TempD
	rts

_cursorDraw
	LDA GLO_TempC
	STA DBG_TextDest + LO
	LDA GLO_TempD
	STA DBG_TextDest + HI
	jmp DBG_Print
.ends
