;****************************************************************
;		     PCE Joystick Helpers			*
;****************************************************************
; ReadJoy:							*
;	Read the state of the first player's controller and	*
; check which buttons have been pressed or released.		*
;****************************************************************
.section "ReadJoy" force
ReadJoy:
	LDA JOY_Current		; Shift down the read from the
	STA JOY_Last		; previous frame.

	LDA #GAMESTICK_SEL	; Hold SEL high and raise CLR in
	STA GAMESTICK_JOYPORT	; order to reset the five-player
	PHA			; adaptor (if attached).
	PLA
	NOP
	NOP
	LDA #(GAMESTICK_CLR | GAMESTICK_SEL)
	STA GAMESTICK_JOYPORT
	PHA
	PLA
	NOP
	NOP

	LDA #GAMESTICK_SEL	; Lower CLR to allow reading from
	STA GAMESTICK_JOYPORT	; the first joypad.
	PHA
	PLA
	NOP
	NOP

	LDA GAMESTICK_JOYPORT	; We can now read in the D-Pad and
	AND #%00001111		; button states. They'll be stored
	STA JOY_Current		; in JOY_Current as follows:
	STZ GAMESTICK_JOYPORT
	PHA			; Bit		7   6   5 4 3 2 1 0
	PLA			; Button	Run Sel 2 1 L R D U
	NOP
	NOP
	LDA GAMESTICK_JOYPORT
	AND #%00001111
	TAY
	LDA NibSwap_Table,Y
	ORA JOY_Current
	EOR #$FF
	STA JOY_Current

	LDA JOY_Current
	EOR JOY_Last
	AND JOY_Current
	STA JOY_Pressed

	LDA JOY_Current
	EOR JOY_Last
	AND JOY_Last
	STA JOY_Released
	rts
.ends
